"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class RDParticipant(ProtocolElement):
    """
    This defines a RD Participant (demographics and pedigree information)
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "adoptedStatus",
        "affectionStatus",
        "ancestries",
        "consanguineousParents",
        "consentStatus",
        "disorderList",
        "gelFamilyId",
        "hpoTermList",
        "isProband",
        "lifeStatus",
        "pedigreeId",
        "sex",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "ancestries": reports_3_0_0.Ancestries,
            "consentStatus": reports_3_0_0.ConsentStatus,
            "disorderList": reports_3_0_0.Disorder,
            "hpoTermList": reports_3_0_0.HpoTerm,
            "inbreedingCoefficient": reports_3_0_0.InbreedingCoefficient,
            "versionControl": reports_3_0_0.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "adoptedStatus": reports_3_0_0.AdoptedStatus,
            "affectionStatus": reports_3_0_0.AffectionStatus,
            "consanguineousParents": reports_3_0_0.TernaryOption,
            "lifeStatus": reports_3_0_0.LifeStatus,
            "monozygotic": reports_3_0_0.TernaryOption,
            "personKaryotipicSex": reports_3_0_0.PersonKaryotipicSex,
            "sex": reports_3_0_0.Sex,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.AdoptedStatus": reports_3_0_0.AdoptedStatus,
            "org.gel.models.report.avro.AffectionStatus": reports_3_0_0.AffectionStatus,
            "org.gel.models.report.avro.Ancestries": reports_3_0_0.Ancestries,
            "org.gel.models.report.avro.TernaryOption": reports_3_0_0.TernaryOption,
            "org.gel.models.report.avro.ConsentStatus": reports_3_0_0.ConsentStatus,
            "org.gel.models.report.avro.Disorder": reports_3_0_0.Disorder,
            "org.gel.models.report.avro.HpoTerm": reports_3_0_0.HpoTerm,
            "org.gel.models.report.avro.InbreedingCoefficient": reports_3_0_0.InbreedingCoefficient,
            "org.gel.models.report.avro.LifeStatus": reports_3_0_0.LifeStatus,
            "org.gel.models.report.avro.TernaryOption": reports_3_0_0.TernaryOption,
            "org.gel.models.report.avro.PersonKaryotipicSex": reports_3_0_0.PersonKaryotipicSex,
            "org.gel.models.report.avro.Sex": reports_3_0_0.Sex,
            "org.gel.models.report.avro.VersionControl": reports_3_0_0.VersionControl,
            "org.gel.models.report.avro.RDParticipant": reports_3_0_0.RDParticipant,
        }

    __slots__ = [
        "adoptedStatus",
        "affectionStatus",
        "ancestries",
        "consanguineousParents",
        "consentStatus",
        "disorderList",
        "gelFamilyId",
        "hpoTermList",
        "isProband",
        "lifeStatus",
        "pedigreeId",
        "sex",
        "versionControl",
        "additionalInformation",
        "consanguineousPopulation",
        "fatherId",
        "gelId",
        "gelSuperFamilyId",
        "inbreedingCoefficient",
        "monozygotic",
        "motherId",
        "personKaryotipicSex",
        "samples",
        "superFatherId",
        "superMotherId",
        "twinGroup",
        "yearOfBirth",
    ]

    def __init__(
        self,
        adoptedStatus,
        affectionStatus,
        ancestries,
        consanguineousParents,
        consentStatus,
        disorderList,
        gelFamilyId,
        hpoTermList,
        isProband,
        lifeStatus,
        pedigreeId,
        sex,
        versionControl,
        additionalInformation=None,
        consanguineousPopulation=None,
        fatherId=None,
        gelId=None,
        gelSuperFamilyId=None,
        inbreedingCoefficient=None,
        monozygotic=None,
        motherId=None,
        personKaryotipicSex=None,
        samples=None,
        superFatherId=None,
        superMotherId=None,
        twinGroup=None,
        yearOfBirth=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.RDParticipant model.

        :param adoptedStatus:
            Adopted Status
        :type adoptedStatus: AdoptedStatus
        :param affectionStatus:
            Affection Status
        :type affectionStatus: AffectionStatus
        :param ancestries:
            Participant's ancestries, defined as Mother's/Father's Ethnic Origin
            and Chi-square test for goodness of fit of this sample to
            1000 Genomes Phase 3 populations
        :type ancestries: Ancestries
        :param consanguineousParents:
            The parents of this participant has a consanguineous relationship
        :type consanguineousParents: TernaryOption
        :param consentStatus:
            What has this participant consented to?     A participant that has
            been consented to the programme should also have sequence
            data associated with them; however     this needs to be
            programmatically checked
        :type consentStatus: ConsentStatus
        :param disorderList:
            Clinical Data (disorders). If the family member is unaffected as per
            affectionStatus then this list is empty
        :type disorderList: list[Disorder]
        :param gelFamilyId:
            Family id which internally translate to a sample set
        :type gelFamilyId: str
        :param hpoTermList:
            Clinical Data (HPO terms)
        :type hpoTermList: list[HpoTerm]
        :param isProband:
            If this field is true, the member should be consider the proband of
            this family
        :type isProband: boolean
        :param lifeStatus:
            Life Status
        :type lifeStatus: LifeStatus
        :param pedigreeId:
            Numbering used to refer to each member of the pedigree
        :type pedigreeId: int
        :param sex:
            Sex of the Participant
        :type sex: Sex
        :param versionControl:
            Model version number
        :type versionControl: VersionControl
        :param additionalInformation:
            We could add a map here to store additional information for example
            URIs to images, ECGs, etc     Null by default
        :type additionalInformation: None | dict[str, str]
        :param consanguineousPopulation:
            Offspring from a consanguineous population
        :type consanguineousPopulation: None | str
        :param fatherId:
            refers to the pedigreeId of the father     Id of the parent, if
            unknown then no parent is referenced. Parents may need to
            be entered even if no data is known     about them in
            order to unambiguously reconstruct the pedigree.
        :type fatherId: None | int
        :param gelId:
            gel internal identifier, only required when the participant belongs to
            the program
        :type gelId: None | str
        :param gelSuperFamilyId:
            superFamily id, this id is built as a concatenation of all families id
            in this superfamily i.e, fam10024_fam100457
        :type gelSuperFamilyId: None | str
        :param inbreedingCoefficient:
            Inbreeding Coefficient Estimation
        :type inbreedingCoefficient: None | InbreedingCoefficient
        :param monozygotic:
            A property of the twinning group but should be entered for all members
        :type monozygotic: None | TernaryOption
        :param motherId:
            refers to the pedigreeId of the mother     Id of the parent, if
            unknown then no parent is referenced. Parents may need to
            be entered even if no data is known     about them in
            order to unambiguously reconstruct the pedigree.
        :type motherId: None | int
        :param personKaryotipicSex:
            Karyotypic sex of the participant as previously established or by
            looking at the GEL genome
        :type personKaryotipicSex: None | PersonKaryotipicSex
        :param samples:
            This is an array containing all the samples that belong to this
            individual, e.g ["LP00002255_GA4"]
        :type samples: None | list[str]
        :param superFatherId:
            this id is built using the original familyId and the original
            pedigreeId of the father
        :type superFatherId: None | int
        :param superMotherId:
            this id is built using the original familyId and the original
            pedigreeId of the mother
        :type superMotherId: None | int
        :param twinGroup:
            Each twin group is numbered, i.e. all members of a group of
            multiparous births receive the same number
        :type twinGroup: None | int
        :param yearOfBirth:
            Year of Birth
        :type yearOfBirth: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
